/* CGA.C */
static int cga_null(void);
int cga_peekb(= unsigned char far *);
int cga_pokeb(unsigned char far *, unsigned char);
int cga_movmem(unsigned char far *, unsigned char far *, int);
int cga_init(void);
int cga_palette(int, int);
int cga_write_row(int, unsigned char far *, register unsigned int);
int cga_clear(void);
int cga_clr_point(unsigned int, unsigned int);
int cga_xor_point(unsigned int, unsigned int, unsigned int);
int cga_get_point(unsigned int, unsigned int);
int cga_set_point(unsigned int, unsigned int, unsigned int);
int cga_mode(int);

/* EGA.C */
static int ega_null(void);
int ega_init(void);
int ega_select_plane(= int);
int ega_write_row(int, unsigned char *, register unsigned int);
int ega_clear(void);
int ega_set_palette(unsigned char, unsigned char, unsigned char, unsigned char);
int ega_clr_point(unsigned int, unsigned int);
int ega_xor_point(unsigned int, unsigned int, unsigned int);
int ega_get_point(unsigned int, unsigned int);
int ega_set_point(unsigned int, unsigned int, unsigned int);
int ega_mode(int);

/* HERC.C */
static int herc_null(void);
int herc_set_page(= int);
int herc_clear(void);
int herc_write_row(unsigned int, char *, unsigned int);
int herc_init(void);
int herc_set_point(unsigned int, unsigned int);
int herc_clr_point(unsigned int, unsigned int);
int herc_get_point(unsigned int, unsigned int);
int herc_xor_point(unsigned int, unsigned int);
int herc_mode(int);

/* PCXDISP.C */
void pcx_load_palette(PCXPIC *);
void pcx_showpic(PCXPIC *, int, int, int);
void pcx_dump_pic(PCXPIC *);

/* PCXFILE.C */
int pcx_getc(uint *, uint *, FILE *, uint);
int pcx_xputc(int, FILE *);
int pcx_putc(unsigned int, unsigned int, FILE *);
int pcx_read_pic(PCXPIC *, FILE *);
int pcx_write_pic(PCXPIC *, FILE *);

/* VGR.C */
int vgr_get_board(void);
int vgr_mode(unsigned char);
void vgr_line(int, int, int, int, int);
void vgr_rectangle(int, int, int, int, int);
void vgr_point(int, int, int);

/* VGRFILL.C */
void vgr_fill(int, int, int);
static void _fill_y(int, int, int);
static void _fill_x(int, int);
static int __fill_x(int, int, int);

/* IBMTIMER.C */
unsigned long ibmpc_stopwatch(int, struct IBMPC_STOPWATCH *);
unsigned long read_ibmpc_time(void);
unsigned int read_ibmpc_timer(void);
unsigned long cvt_ibmpc_time(unsigned long, unsigned int *, unsigned int *, unsigned int *);


