#include <dos.h>
#include <fcntl.h>
#include <io.h>

typedef unsigned char byte;
typedef unsigned int word;

extern char far *ajuri;	/* Ajurin osoite */
extern word versio;		/* Ajurin versio */
extern word status;		/* Tilasana */

int Voc_lataa_ajuri(void) {
	int handle;
	word para,segment,luettu;
	char far *temp;
	if (_dos_open("CT-VOICE.DRV",O_RDONLY,&handle)!=0) return(1);
	para=1+filelength(handle)/16;
	if (_dos_allocmem(para,&segment)!=0) return(2);
	FP_SEG(ajuri)=segment;
	FP_OFF(ajuri)=0;
	temp=ajuri;
	do {
		_dos_read(handle,temp,0x1024,&luettu);
		temp+=luettu;
	} while (luettu==0x1024);
	_dos_close(handle);
	return(0);
}

char far * Voc_lataa(char *tiedosto) {
	int handle;
	word para,segment,luettu;
	char far *temp,far *data;
	if (_dos_open(tiedosto,O_RDONLY,&handle)!=0) return(0);
	para=1+filelength(handle)/16;
	if (_dos_allocmem(para,&segment)!=0) return(0);
	data=(char far *)MK_FP(segment,0);
	temp=data;
	do {
		_dos_read(handle,temp,0x1024,&luettu);
		temp+=luettu;
	} while (luettu==0x1024);
	_dos_close(handle);
	return(data);
}

void Voc_poista(char far *osoite) {
	_dos_freemem(FP_SEG(osoite));
}

void Voc_versio(void) {
	asm {
		mov bx,0
		call ajuri
		mov versio,ax
	}
}

void Voc_portti(word portti) {
	asm {
		mov bx,1
		mov ax,portti
		call ajuri
	}
}

void Voc_DMA(word dma) {
	asm {
		mov bx,2
		mov ax,dma
		call ajuri
	}
}

void Voc_tilasana(void) {
	word segmentti,siirros;
	segmentti=FP_SEG(&status);
	siirros=FP_OFF(&status);
	asm {
		mov bx,5
		mov es,segmentti
		mov di,siirros
		call ajuri
	}
}

int Voc_init(void) {
	int status;
	asm {
		mov bx,3
		call ajuri
		mov status,ax
	}
	return(status);
}

void Voc_terminoi(void) {
	asm {
		mov bx,9
		call ajuri
	}
}

void Voc_kaiutin(word asento) {
	asm {
		mov bx,4
		mov ax,asento
		call ajuri
	}
}

/* Tll estetn kntjn varoitukset siit, etteivt int-tyyppiset */
/* funktiot palauta arvoja. Palautusarvothan talletetaan AX-rekisteriin, */
/* ja ne ovat siell valmiiksi ajurin kutsun jlkeen. */
#pragma warn -rvl
int Voc_soita(byte far *osoite) {
	word segmentti,siirros;
	segmentti=FP_SEG(osoite);
	siirros=FP_OFF(osoite);
	siirros+=osoite[20];
	asm {
		mov bx,6
		mov ax,segmentti
		mov es,ax
		mov di,siirros
		call ajuri
	}
}

void Voc_lopeta(void) {
	asm {
		mov bx,8
		call ajuri
	}
}

int Voc_paussi(void) {
	asm {
		mov bx,10
		call ajuri
	}
}

int Voc_jatka(void) {
	asm {
		mov bx,11
		call ajuri
	}
}

int Voc_looppi(void) {
	asm {
		mov bx,12
		call ajuri
	}
}
#pragma warn +rvl

int Voc_tee_kaikki(word portti,word dma) {
	if (Voc_lataa_ajuri()) return(1);
	Voc_versio();
	Voc_portti(portti);
	Voc_DMA(dma);
	Voc_tilasana();
	return(Voc_init());
}