IDEAL
P486
MODEL FLAT

PUBLIC	do_water_

;
CODESEG
;

PICWIDTH  EQU 320
PICHEIGHT EQU 200
SELFMOD   EQU 012345678h

extrn _picwidth:DWORD
extrn _picheight:DWORD
;
do_water_:				; in :
					;   esi = current watermap
					;   edi = previous watermap
					;   edx = picture buffer
					;   ebx = screen buffer
					;
					; modifies : all registers
					;
					; out : none
;

	pushad				; just to make sure ebp stays
					; as watcom fucks up if it is changed

        mov     eax,[_picwidth]
        sal     eax,1
        add     esi,eax
        add     edi,eax
        add     edx,eax
        add     ebx,eax

        mov     [DWORD sm1+3],edx       ; let's selfmod the code a bit
        mov     eax,[_picheight]
        sub     eax,4
        imul    eax,[_picwidth]
        mov     [DWORD sm3+2],eax

	push	ebx

        mov     [DWORD sm2+2],ebx ;


	xor	ecx,ecx
	xor	edx,edx

	jmp	loop1			; flush IPQ

loop1:	movsx	ebx,[WORD edi-2]
	movsx	eax,[WORD edi+2]
	movsx	edx,[WORD edi-(PICWIDTH*2)]
	movsx	ebp,[WORD edi+(PICWIDTH*2)]
	add	eax,edx
	add	ebx,ebp
	add	ebx,eax
	sar	ebx,1
   ;     jz      SHORT next_pixel        ; forget the rest of the handling..

	movsx	eax,[WORD esi]
	sub	ebx,eax

	mov	eax,ebx 		; kill the wave a bit..
	sar	eax,4

	sub	ebx,eax

	cmp	ebx,16383		; keep the height value in
	jle	SHORT ok1		; bounds
	mov	ebx,16383
	jmp	SHORT ok_2

ok1:	cmp	ebx,-16383
	jge	SHORT ok_2
	mov	ebx,-16383

ok_2:	mov	[esi],bx	       ; save the value

        sar     ebx,5
        neg     ebx

sm1:    mov     al,[ecx+ebx+SELFMOD]    ; read from picture
sm2:    mov     [ecx+SELFMOD],al        ; blit

next_pixel:

	add	esi,2			; advance pointers
	add	edi,2

	inc	ecx			; still another pixel?
sm3:    cmp     ecx,SELFMOD
	jl	SHORT loop1		; oh yes, let's JUMP!

	pop	esi			; let's blit

	popad

	ret

;
END
